# coding: utf-8

"""
    Antimatter Public API

    Interact with the Antimatter Cloud API

    The version of the OpenAPI document: 2.0.10
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class ReadContextDetailsAttachedPoliciesInner(BaseModel):
    """
    ReadContextDetailsAttachedPoliciesInner
    """ # noqa: E501
    policy_id: Annotated[str, Field(strict=True)] = Field(description="An identifier for a potentially imported policy", alias="policyID")
    policy_name: Annotated[str, Field(strict=True, max_length=256)] = Field(alias="policyName")
    imported: StrictBool = Field(description="true if this policy is imported")
    source_domain_id: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="A globally unique identifier for a domain", alias="sourceDomainID")
    source_domain_name: Optional[StrictStr] = Field(default=None, alias="sourceDomainName")
    status: Optional[StrictStr] = Field(default=None, description="This is the actual status of this binding, looking at our config, the peer config, and the actual  availability of the policy ")
    status_source: Optional[StrictStr] = Field(default=None, description="This defines why the policy has the above status ", alias="statusSource")
    __properties: ClassVar[List[str]] = ["policyID", "policyName", "imported", "sourceDomainID", "sourceDomainName", "status", "statusSource"]

    @field_validator('policy_id')
    def policy_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^((dm-[1-9A-HJ-NP-Za-km-z]{11}|[a-z][a-z0-9_]{2,31})::)?pl-[a-z0-9]{16}$", value):
            raise ValueError(r"must validate the regular expression /^((dm-[1-9A-HJ-NP-Za-km-z]{11}|[a-z][a-z0-9_]{2,31})::)?pl-[a-z0-9]{16}$/")
        return value

    @field_validator('policy_name')
    def policy_name_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[a-zA-Z0-9_ \/-]{2,256}$", value):
            raise ValueError(r"must validate the regular expression /^[a-zA-Z0-9_ \/-]{2,256}$/")
        return value

    @field_validator('source_domain_id')
    def source_domain_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^dm-[1-9A-HJ-NP-Za-km-z]{11}$", value):
            raise ValueError(r"must validate the regular expression /^dm-[1-9A-HJ-NP-Za-km-z]{11}$/")
        return value

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Attached', 'NotAttached', 'Unavailable']):
            raise ValueError("must be one of enum values ('Attached', 'NotAttached', 'Unavailable')")
        return value

    @field_validator('status_source')
    def status_source_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Default', 'PeerDefault', 'PeerContextConfiguration', 'ContextConfiguration', 'NoConfiguration']):
            raise ValueError("must be one of enum values ('Default', 'PeerDefault', 'PeerContextConfiguration', 'ContextConfiguration', 'NoConfiguration')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReadContextDetailsAttachedPoliciesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReadContextDetailsAttachedPoliciesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "policyID": obj.get("policyID"),
            "policyName": obj.get("policyName"),
            "imported": obj.get("imported"),
            "sourceDomainID": obj.get("sourceDomainID"),
            "sourceDomainName": obj.get("sourceDomainName"),
            "status": obj.get("status"),
            "statusSource": obj.get("statusSource")
        })
        return _obj


